# coding: utf-8

"""
    Climate

    The Aladdin Climate Data API exposes physical, transition, and temperature alignment analytics as of a given date. Users can retrieve data for selected entity types by specifying the desired datapoints for each climate risk type and scenario. The Aladdin Climate Meta Data API outlines the datapoints available across physical, transition, and temperature alignment analytics.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_analytics.agraph.analytics.data.climate.v1.ClimateAPI.models.v1_data_type import V1DataType
from asdk_plugin_analytics.agraph.analytics.data.climate.v1.ClimateAPI.models.v1_id_type import V1IdType

class V1ClimateMetadata(BaseModel):
    """
    V1ClimateMetadata
    """
    metric_code: Optional[StrictStr] = Field(None, alias="metricCode")
    metric_name: Optional[StrictStr] = Field(None, alias="metricName")
    description: Optional[StrictStr] = None
    category: Optional[StrictStr] = None
    id_types: Optional[conlist(V1IdType)] = Field(None, alias="idTypes")
    data_type: Optional[V1DataType] = Field(None, alias="dataType")
    unit: Optional[StrictStr] = None
    metadata_ext: Optional[Dict[str, StrictStr]] = Field(None, alias="metadataExt")
    __properties = ["metricCode", "metricName", "description", "category", "idTypes", "dataType", "unit", "metadataExt"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ClimateMetadata:
        """Create an instance of V1ClimateMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ClimateMetadata:
        """Create an instance of V1ClimateMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ClimateMetadata.parse_obj(obj)

        _obj = V1ClimateMetadata.parse_obj({
            "metric_code": obj.get("metricCode"),
            "metric_name": obj.get("metricName"),
            "description": obj.get("description"),
            "category": obj.get("category"),
            "id_types": obj.get("idTypes"),
            "data_type": obj.get("dataType"),
            "unit": obj.get("unit"),
            "metadata_ext": obj.get("metadataExt")
        })
        return _obj

