# coding: utf-8

"""
    Climate

    The Aladdin Climate Data API exposes physical, transition, and temperature alignment analytics as of a given date. Users can retrieve data for selected entity types by specifying the desired datapoints for each climate risk type and scenario. The Aladdin Climate Meta Data API outlines the datapoints available across physical, transition, and temperature alignment analytics.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_analytics.agraph.analytics.data.climate.v1.ClimateAPI.models.v1_climate_scenario import V1ClimateScenario
from asdk_plugin_analytics.agraph.analytics.data.climate.v1.ClimateAPI.models.v1_metric import V1Metric
from asdk_plugin_analytics.agraph.analytics.data.climate.v1.ClimateAPI.models.v1_metric_type import V1MetricType
from asdk_plugin_analytics.agraph.analytics.data.climate.v1.ClimateAPI.models.v1_model_parameter import V1ModelParameter

class V1ClimateScenarioDataSet(BaseModel):
    """
    V1ClimateScenarioDataSet
    """
    as_of_date: Optional[date] = Field(None, alias="asOfDate")
    risk_date: Optional[date] = Field(None, alias="riskDate")
    metric_type: Optional[V1MetricType] = Field(None, alias="metricType")
    climate_scenario: Optional[V1ClimateScenario] = Field(None, alias="climateScenario")
    metrics: Optional[conlist(V1Metric)] = None
    version: Optional[StrictStr] = None
    model_parameters: Optional[conlist(V1ModelParameter)] = Field(None, alias="modelParameters")
    __properties = ["asOfDate", "riskDate", "metricType", "climateScenario", "metrics", "version", "modelParameters"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ClimateScenarioDataSet:
        """Create an instance of V1ClimateScenarioDataSet from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of climate_scenario
        if self.climate_scenario:
            _dict['climateScenario'] = self.climate_scenario.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in metrics (list)
        _items = []
        if self.metrics:
            for _item in self.metrics:
                if _item:
                    _items.append(_item.to_dict())
            _dict['metrics'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in model_parameters (list)
        _items = []
        if self.model_parameters:
            for _item in self.model_parameters:
                if _item:
                    _items.append(_item.to_dict())
            _dict['modelParameters'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ClimateScenarioDataSet:
        """Create an instance of V1ClimateScenarioDataSet from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ClimateScenarioDataSet.parse_obj(obj)

        _obj = V1ClimateScenarioDataSet.parse_obj({
            "as_of_date": obj.get("asOfDate"),
            "risk_date": obj.get("riskDate"),
            "metric_type": obj.get("metricType"),
            "climate_scenario": V1ClimateScenario.from_dict(obj.get("climateScenario")) if obj.get("climateScenario") is not None else None,
            "metrics": [V1Metric.from_dict(_item) for _item in obj.get("metrics")] if obj.get("metrics") is not None else None,
            "version": obj.get("version"),
            "model_parameters": [V1ModelParameter.from_dict(_item) for _item in obj.get("modelParameters")] if obj.get("modelParameters") is not None else None
        })
        return _obj

