# coding: utf-8

"""
    Climate

    The Aladdin Climate Data API exposes physical, transition, and temperature alignment analytics as of a given date. Users can retrieve data for selected entity types by specifying the desired datapoints for each climate risk type and scenario. The Aladdin Climate Meta Data API outlines the datapoints available across physical, transition, and temperature alignment analytics.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_analytics.agraph.analytics.data.climate.v1.ClimateAPI.models.v1_metric_value import V1MetricValue
from asdk_plugin_analytics.agraph.analytics.data.climate.v1.ClimateAPI.models.v1_output_value import V1OutputValue

class V1Metric(BaseModel):
    """
    V1Metric
    """
    metric_code: Optional[StrictStr] = Field(None, alias="metricCode")
    metric_value: Optional[V1MetricValue] = Field(None, alias="metricValue")
    output_values: Optional[conlist(V1OutputValue)] = Field(None, alias="outputValues")
    __properties = ["metricCode", "metricValue", "outputValues"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1Metric:
        """Create an instance of V1Metric from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of metric_value
        if self.metric_value:
            _dict['metricValue'] = self.metric_value.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in output_values (list)
        _items = []
        if self.output_values:
            for _item in self.output_values:
                if _item:
                    _items.append(_item.to_dict())
            _dict['outputValues'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1Metric:
        """Create an instance of V1Metric from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1Metric.parse_obj(obj)

        _obj = V1Metric.parse_obj({
            "metric_code": obj.get("metricCode"),
            "metric_value": V1MetricValue.from_dict(obj.get("metricValue")) if obj.get("metricValue") is not None else None,
            "output_values": [V1OutputValue.from_dict(_item) for _item in obj.get("outputValues")] if obj.get("outputValues") is not None else None
        })
        return _obj

