# coding: utf-8

"""
    Climate

    The Aladdin Climate Data API exposes physical, transition, and temperature alignment analytics as of a given date. Users can retrieve data for selected entity types by specifying the desired datapoints for each climate risk type and scenario. The Aladdin Climate Meta Data API outlines the datapoints available across physical, transition, and temperature alignment analytics.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, conlist
from asdk_plugin_analytics.agraph.analytics.data.climate.v1.ClimateAPI.models.v1_climate_metadata import V1ClimateMetadata
from asdk_plugin_analytics.agraph.analytics.data.climate.v1.ClimateAPI.models.v1_field_mapping import V1FieldMapping
from asdk_plugin_analytics.agraph.analytics.data.climate.v1.ClimateAPI.models.v1_scenario_option import V1ScenarioOption

class V1RetrieveClimateMetadataResponse(BaseModel):
    """
    V1RetrieveClimateMetadataResponse
    """
    climate_metadata: Optional[conlist(V1ClimateMetadata)] = Field(None, alias="climateMetadata")
    scenario_options: Optional[conlist(V1ScenarioOption)] = Field(None, alias="scenarioOptions")
    field_mappings: Optional[conlist(V1FieldMapping)] = Field(None, alias="fieldMappings")
    __properties = ["climateMetadata", "scenarioOptions", "fieldMappings"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1RetrieveClimateMetadataResponse:
        """Create an instance of V1RetrieveClimateMetadataResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in climate_metadata (list)
        _items = []
        if self.climate_metadata:
            for _item in self.climate_metadata:
                if _item:
                    _items.append(_item.to_dict())
            _dict['climateMetadata'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in scenario_options (list)
        _items = []
        if self.scenario_options:
            for _item in self.scenario_options:
                if _item:
                    _items.append(_item.to_dict())
            _dict['scenarioOptions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in field_mappings (list)
        _items = []
        if self.field_mappings:
            for _item in self.field_mappings:
                if _item:
                    _items.append(_item.to_dict())
            _dict['fieldMappings'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1RetrieveClimateMetadataResponse:
        """Create an instance of V1RetrieveClimateMetadataResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1RetrieveClimateMetadataResponse.parse_obj(obj)

        _obj = V1RetrieveClimateMetadataResponse.parse_obj({
            "climate_metadata": [V1ClimateMetadata.from_dict(_item) for _item in obj.get("climateMetadata")] if obj.get("climateMetadata") is not None else None,
            "scenario_options": [V1ScenarioOption.from_dict(_item) for _item in obj.get("scenarioOptions")] if obj.get("scenarioOptions") is not None else None,
            "field_mappings": [V1FieldMapping.from_dict(_item) for _item in obj.get("fieldMappings")] if obj.get("fieldMappings") is not None else None
        })
        return _obj

