# coding: utf-8

"""
    ESG Data

    The ESG Data API offers a centralized source of ESG data and meta data across multiple vendors. The API retrieves ESG data by asset and issuer from multiple vendors, providing the data in one digestible schema. Retrieve ESG data for selected assets and issuers by providing entity id, provider id, date(s) and measure name. Meta data on ESG data measures can be retrieved by selecting a provider, provider category and unique measure names. Time Series API in alpha version, changes may be made at any time.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from asdk_plugin_analytics.agraph.analytics.data.esg.v1.EsgDataAPI.models.v1_esg_provider_data_point import V1ESGProviderDataPoint
from asdk_plugin_analytics.agraph.analytics.data.esg.v1.EsgDataAPI.models.v1_id_type import V1IdType

class V1ESGDataSet(BaseModel):
    """
    Dataset response to request client.
    """
    id: Optional[StrictStr] = None
    id_type: Optional[V1IdType] = Field(None, alias="idType")
    provider_data_point: Optional[V1ESGProviderDataPoint] = Field(None, alias="providerDataPoint")
    issuer_id: Optional[StrictStr] = Field(None, alias="issuerId")
    __properties = ["id", "idType", "providerDataPoint", "issuerId"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ESGDataSet:
        """Create an instance of V1ESGDataSet from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of provider_data_point
        if self.provider_data_point:
            _dict['providerDataPoint'] = self.provider_data_point.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ESGDataSet:
        """Create an instance of V1ESGDataSet from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ESGDataSet.parse_obj(obj)

        _obj = V1ESGDataSet.parse_obj({
            "id": obj.get("id"),
            "id_type": obj.get("idType"),
            "provider_data_point": V1ESGProviderDataPoint.from_dict(obj.get("providerDataPoint")) if obj.get("providerDataPoint") is not None else None,
            "issuer_id": obj.get("issuerId")
        })
        return _obj

