# coding: utf-8

"""
    ESG Data

    The ESG Data API offers a centralized source of ESG data and meta data across multiple vendors. The API retrieves ESG data by asset and issuer from multiple vendors, providing the data in one digestible schema. Retrieve ESG data for selected assets and issuers by providing entity id, provider id, date(s) and measure name. Meta data on ESG data measures can be retrieved by selecting a provider, provider category and unique measure names. Time Series API in alpha version, changes may be made at any time.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_analytics.agraph.analytics.data.esg.v1.EsgDataAPI.models.v1_esg_data_set import V1ESGDataSet
from asdk_plugin_analytics.agraph.analytics.data.esg.v1.EsgDataAPI.models.v1_esg_exception import V1ESGException

class V1ESGDataSetResponse(BaseModel):
    """
    V1ESGDataSetResponse
    """
    esg_data_sets: conlist(V1ESGDataSet) = Field(..., alias="esgDataSets")
    next_page_token: Optional[StrictStr] = Field(None, alias="nextPageToken", description="A token, which can be sent as `page_token` to retrieve the next page. If this field is omitted, there are no subsequent pages.")
    esg_exceptions: Optional[conlist(V1ESGException)] = Field(None, alias="esgExceptions")
    __properties = ["esgDataSets", "nextPageToken", "esgExceptions"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ESGDataSetResponse:
        """Create an instance of V1ESGDataSetResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in esg_data_sets (list)
        _items = []
        if self.esg_data_sets:
            for _item in self.esg_data_sets:
                if _item:
                    _items.append(_item.to_dict())
            _dict['esgDataSets'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in esg_exceptions (list)
        _items = []
        if self.esg_exceptions:
            for _item in self.esg_exceptions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['esgExceptions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ESGDataSetResponse:
        """Create an instance of V1ESGDataSetResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ESGDataSetResponse.parse_obj(obj)

        _obj = V1ESGDataSetResponse.parse_obj({
            "esg_data_sets": [V1ESGDataSet.from_dict(_item) for _item in obj.get("esgDataSets")] if obj.get("esgDataSets") is not None else None,
            "next_page_token": obj.get("nextPageToken"),
            "esg_exceptions": [V1ESGException.from_dict(_item) for _item in obj.get("esgExceptions")] if obj.get("esgExceptions") is not None else None
        })
        return _obj

