# coding: utf-8

"""
    ESG Data

    The ESG Data API offers a centralized source of ESG data and meta data across multiple vendors. The API retrieves ESG data by asset and issuer from multiple vendors, providing the data in one digestible schema. Retrieve ESG data for selected assets and issuers by providing entity id, provider id, date(s) and measure name. Meta data on ESG data measures can be retrieved by selecting a provider, provider category and unique measure names. Time Series API in alpha version, changes may be made at any time.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist
from asdk_plugin_analytics.agraph.analytics.data.esg.v1.EsgDataAPI.models.v1_esg_measurement import V1ESGMeasurement

class V1ESGProviderDataPoint(BaseModel):
    """
    V1ESGProviderDataPoint
    """
    provider_id: StrictStr = Field(..., alias="providerId")
    as_of_date: date = Field(..., alias="asOfDate")
    measurements: conlist(V1ESGMeasurement) = Field(...)
    effective_date: date = Field(..., alias="effectiveDate")
    parent_issuer_id: Optional[StrictStr] = Field(None, alias="parentIssuerId")
    issuer_traversal: Optional[StrictBool] = Field(None, alias="issuerTraversal")
    __properties = ["providerId", "asOfDate", "measurements", "effectiveDate", "parentIssuerId", "issuerTraversal"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ESGProviderDataPoint:
        """Create an instance of V1ESGProviderDataPoint from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in measurements (list)
        _items = []
        if self.measurements:
            for _item in self.measurements:
                if _item:
                    _items.append(_item.to_dict())
            _dict['measurements'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ESGProviderDataPoint:
        """Create an instance of V1ESGProviderDataPoint from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ESGProviderDataPoint.parse_obj(obj)

        _obj = V1ESGProviderDataPoint.parse_obj({
            "provider_id": obj.get("providerId"),
            "as_of_date": obj.get("asOfDate"),
            "measurements": [V1ESGMeasurement.from_dict(_item) for _item in obj.get("measurements")] if obj.get("measurements") is not None else None,
            "effective_date": obj.get("effectiveDate"),
            "parent_issuer_id": obj.get("parentIssuerId"),
            "issuer_traversal": obj.get("issuerTraversal")
        })
        return _obj

