# coding: utf-8

"""
    ESG Data

    The ESG Data API offers a centralized source of ESG data and meta data across multiple vendors. The API retrieves ESG data by asset and issuer from multiple vendors, providing the data in one digestible schema. Retrieve ESG data for selected assets and issuers by providing entity id, provider id, date(s) and measure name. Meta data on ESG data measures can be retrieved by selecting a provider, provider category and unique measure names. Time Series API in alpha version, changes may be made at any time.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class V1IdType(str, Enum):
    """
    - ID_TYPE_UNSPECIFIED: Default Value - Error is thrown in this case  - ID_TYPE_ALADDIN_ISSUER: ALADDIN_ISSUER - The id is an Aladdin issuer  - ID_TYPE_ASSET_ID: ASSET_ID - This id is the id of the asset, could be a cusip, z_cusip or any other thing along those lines
    """

    """
    allowed enum values
    """
    ID_TYPE_UNSPECIFIED = 'ID_TYPE_UNSPECIFIED'
    ID_TYPE_ALADDIN_ISSUER = 'ID_TYPE_ALADDIN_ISSUER'
    ID_TYPE_ASSET_ID = 'ID_TYPE_ASSET_ID'

    @classmethod
    def from_json(cls, json_str: str) -> V1IdType:
        """Create an instance of V1IdType from a JSON string"""
        return V1IdType(json.loads(json_str))


