# coding: utf-8

"""
    Risk Governance - Configuration

    Retrieve, update, and create configurations which drive Risk Governance behaviours and Risk Radar UI choices.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskConfigAPI.models.v1_custom_evaluation_metric_config_record import V1CustomEvaluationMetricConfigRecord
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskConfigAPI.models.v1_display_config_node import V1DisplayConfigNode
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskConfigAPI.models.v1_display_value_record_list import V1DisplayValueRecordList
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskConfigAPI.models.v1_reference_config_record import V1ReferenceConfigRecord
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskConfigAPI.models.v1_resolved_reference_config_record import V1ResolvedReferenceConfigRecord

class V1ConfigRecord(BaseModel):
    """
    V1ConfigRecord
    """
    generic_config_record: Optional[Dict[str, Any]] = Field(None, alias="genericConfigRecord")
    display_config_record: Optional[V1DisplayConfigNode] = Field(None, alias="displayConfigRecord")
    display_value_list: Optional[V1DisplayValueRecordList] = Field(None, alias="displayValueList")
    reference_config_record: Optional[V1ReferenceConfigRecord] = Field(None, alias="referenceConfigRecord")
    resolved_reference_config_record: Optional[V1ResolvedReferenceConfigRecord] = Field(None, alias="resolvedReferenceConfigRecord")
    custom_metric_config_record: Optional[V1CustomEvaluationMetricConfigRecord] = Field(None, alias="customMetricConfigRecord")
    __properties = ["genericConfigRecord", "displayConfigRecord", "displayValueList", "referenceConfigRecord", "resolvedReferenceConfigRecord", "customMetricConfigRecord"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ConfigRecord:
        """Create an instance of V1ConfigRecord from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of display_config_record
        if self.display_config_record:
            _dict['displayConfigRecord'] = self.display_config_record.to_dict()
        # override the default output from pydantic by calling `to_dict()` of display_value_list
        if self.display_value_list:
            _dict['displayValueList'] = self.display_value_list.to_dict()
        # override the default output from pydantic by calling `to_dict()` of reference_config_record
        if self.reference_config_record:
            _dict['referenceConfigRecord'] = self.reference_config_record.to_dict()
        # override the default output from pydantic by calling `to_dict()` of resolved_reference_config_record
        if self.resolved_reference_config_record:
            _dict['resolvedReferenceConfigRecord'] = self.resolved_reference_config_record.to_dict()
        # override the default output from pydantic by calling `to_dict()` of custom_metric_config_record
        if self.custom_metric_config_record:
            _dict['customMetricConfigRecord'] = self.custom_metric_config_record.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ConfigRecord:
        """Create an instance of V1ConfigRecord from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ConfigRecord.parse_obj(obj)

        _obj = V1ConfigRecord.parse_obj({
            "generic_config_record": obj.get("genericConfigRecord"),
            "display_config_record": V1DisplayConfigNode.from_dict(obj.get("displayConfigRecord")) if obj.get("displayConfigRecord") is not None else None,
            "display_value_list": V1DisplayValueRecordList.from_dict(obj.get("displayValueList")) if obj.get("displayValueList") is not None else None,
            "reference_config_record": V1ReferenceConfigRecord.from_dict(obj.get("referenceConfigRecord")) if obj.get("referenceConfigRecord") is not None else None,
            "resolved_reference_config_record": V1ResolvedReferenceConfigRecord.from_dict(obj.get("resolvedReferenceConfigRecord")) if obj.get("resolvedReferenceConfigRecord") is not None else None,
            "custom_metric_config_record": V1CustomEvaluationMetricConfigRecord.from_dict(obj.get("customMetricConfigRecord")) if obj.get("customMetricConfigRecord") is not None else None
        })
        return _obj

