# coding: utf-8

"""
    Risk Governance - Configuration

    Retrieve, update, and create configurations which drive Risk Governance behaviours and Risk Radar UI choices.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, Optional
from pydantic import BaseModel, Field
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskConfigAPI.models.v1_display_value_record import V1DisplayValueRecord

class V1DisplayValueRecordList(BaseModel):
    """
    V1DisplayValueRecordList
    """
    display_values: Optional[Dict[str, V1DisplayValueRecord]] = Field(None, alias="displayValues")
    __properties = ["displayValues"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1DisplayValueRecordList:
        """Create an instance of V1DisplayValueRecordList from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each value in display_values (dict)
        _field_dict = {}
        if self.display_values:
            for _key in self.display_values:
                if self.display_values[_key]:
                    _field_dict[_key] = self.display_values[_key].to_dict()
            _dict['displayValues'] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1DisplayValueRecordList:
        """Create an instance of V1DisplayValueRecordList from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1DisplayValueRecordList.parse_obj(obj)

        _obj = V1DisplayValueRecordList.parse_obj({
            "display_values": dict(
                (_k, V1DisplayValueRecord.from_dict(_v))
                for _k, _v in obj.get("displayValues").items()
            )
            if obj.get("displayValues") is not None
            else None
        })
        return _obj

