# coding: utf-8

"""
    Risk Governance - Configuration

    Retrieve, update, and create configurations which drive Risk Governance behaviours and Risk Radar UI choices.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, conlist
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskConfigAPI.models.v1_risk_config import V1RiskConfig

class V1ListRiskConfigRevisionsResponse(BaseModel):
    """
    V1ListRiskConfigRevisionsResponse
    """
    risk_configs: Optional[conlist(V1RiskConfig)] = Field(None, alias="riskConfigs")
    __properties = ["riskConfigs"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ListRiskConfigRevisionsResponse:
        """Create an instance of V1ListRiskConfigRevisionsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in risk_configs (list)
        _items = []
        if self.risk_configs:
            for _item in self.risk_configs:
                if _item:
                    _items.append(_item.to_dict())
            _dict['riskConfigs'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ListRiskConfigRevisionsResponse:
        """Create an instance of V1ListRiskConfigRevisionsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ListRiskConfigRevisionsResponse.parse_obj(obj)

        _obj = V1ListRiskConfigRevisionsResponse.parse_obj({
            "risk_configs": [V1RiskConfig.from_dict(_item) for _item in obj.get("riskConfigs")] if obj.get("riskConfigs") is not None else None
        })
        return _obj

