# coding: utf-8

"""
    Risk Governance - Configuration

    Retrieve, update, and create configurations which drive Risk Governance behaviours and Risk Radar UI choices.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class V1ReferenceConfigRecord(BaseModel):
    """
    V1ReferenceConfigRecord
    """
    reference_config_type: Optional[StrictStr] = Field(None, alias="referenceConfigType")
    display_order: StrictInt = Field(..., alias="displayOrder")
    reference_config_nodes: Optional[Dict[str, V1ReferenceConfigRecord]] = Field(None, alias="referenceConfigNodes")
    __properties = ["referenceConfigType", "displayOrder", "referenceConfigNodes"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ReferenceConfigRecord:
        """Create an instance of V1ReferenceConfigRecord from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each value in reference_config_nodes (dict)
        _field_dict = {}
        if self.reference_config_nodes:
            for _key in self.reference_config_nodes:
                if self.reference_config_nodes[_key]:
                    _field_dict[_key] = self.reference_config_nodes[_key].to_dict()
            _dict['referenceConfigNodes'] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ReferenceConfigRecord:
        """Create an instance of V1ReferenceConfigRecord from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ReferenceConfigRecord.parse_obj(obj)

        _obj = V1ReferenceConfigRecord.parse_obj({
            "reference_config_type": obj.get("referenceConfigType"),
            "display_order": obj.get("displayOrder"),
            "reference_config_nodes": dict(
                (_k, V1ReferenceConfigRecord.from_dict(_v))
                for _k, _v in obj.get("referenceConfigNodes").items()
            )
            if obj.get("referenceConfigNodes") is not None
            else None
        })
        return _obj

