# coding: utf-8

"""
    Risk Governance - Configuration

    Retrieve, update, and create configurations which drive Risk Governance behaviours and Risk Radar UI choices.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskConfigAPI.models.v1_retrieve_risk_config_request_compound_key import V1RetrieveRiskConfigRequestCompoundKey
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskConfigAPI.models.v1_retrieve_risk_config_request_config_id import V1RetrieveRiskConfigRequestConfigId

class V1RetrieveRiskConfigByIdRequest(BaseModel):
    """
    V1RetrieveRiskConfigByIdRequest
    """
    retrieve_risk_config_request_config_id: Optional[V1RetrieveRiskConfigRequestConfigId] = Field(None, alias="retrieveRiskConfigRequestConfigId")
    retrieve_risk_config_request_compound_key: Optional[V1RetrieveRiskConfigRequestCompoundKey] = Field(None, alias="retrieveRiskConfigRequestCompoundKey")
    __properties = ["retrieveRiskConfigRequestConfigId", "retrieveRiskConfigRequestCompoundKey"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1RetrieveRiskConfigByIdRequest:
        """Create an instance of V1RetrieveRiskConfigByIdRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of retrieve_risk_config_request_config_id
        if self.retrieve_risk_config_request_config_id:
            _dict['retrieveRiskConfigRequestConfigId'] = self.retrieve_risk_config_request_config_id.to_dict()
        # override the default output from pydantic by calling `to_dict()` of retrieve_risk_config_request_compound_key
        if self.retrieve_risk_config_request_compound_key:
            _dict['retrieveRiskConfigRequestCompoundKey'] = self.retrieve_risk_config_request_compound_key.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1RetrieveRiskConfigByIdRequest:
        """Create an instance of V1RetrieveRiskConfigByIdRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1RetrieveRiskConfigByIdRequest.parse_obj(obj)

        _obj = V1RetrieveRiskConfigByIdRequest.parse_obj({
            "retrieve_risk_config_request_config_id": V1RetrieveRiskConfigRequestConfigId.from_dict(obj.get("retrieveRiskConfigRequestConfigId")) if obj.get("retrieveRiskConfigRequestConfigId") is not None else None,
            "retrieve_risk_config_request_compound_key": V1RetrieveRiskConfigRequestCompoundKey.from_dict(obj.get("retrieveRiskConfigRequestCompoundKey")) if obj.get("retrieveRiskConfigRequestCompoundKey") is not None else None
        })
        return _obj

