# coding: utf-8

"""
    Risk Governance - Configuration

    Retrieve, update, and create configurations which drive Risk Governance behaviours and Risk Radar UI choices.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskConfigAPI.models.risk_config_config_entity_type import RiskConfigConfigEntityType

class V1RetrieveRiskConfigRequestCompoundKeyItem(BaseModel):
    """
    V1RetrieveRiskConfigRequestCompoundKeyItem
    """
    config_type: StrictStr = Field(..., alias="configType")
    config_entity_type: Optional[RiskConfigConfigEntityType] = Field(None, alias="configEntityType")
    config_entity_ids: conlist(StrictStr) = Field(..., alias="configEntityIds")
    __properties = ["configType", "configEntityType", "configEntityIds"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1RetrieveRiskConfigRequestCompoundKeyItem:
        """Create an instance of V1RetrieveRiskConfigRequestCompoundKeyItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1RetrieveRiskConfigRequestCompoundKeyItem:
        """Create an instance of V1RetrieveRiskConfigRequestCompoundKeyItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1RetrieveRiskConfigRequestCompoundKeyItem.parse_obj(obj)

        _obj = V1RetrieveRiskConfigRequestCompoundKeyItem.parse_obj({
            "config_type": obj.get("configType"),
            "config_entity_type": obj.get("configEntityType"),
            "config_entity_ids": obj.get("configEntityIds")
        })
        return _obj

