# coding: utf-8

"""
    Risk Governance - Custom Evaluation Metric

    Upload or Retreive Custom Evaluation Metric to be used for Rule evaluation in Risk Radar.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class V1MetricValue(BaseModel):
    """
    V1MetricValue
    """
    metric_value_integer: Optional[StrictStr] = Field(None, alias="metricValueInteger")
    metric_value_double: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="metricValueDouble")
    __properties = ["metricValueInteger", "metricValueDouble"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1MetricValue:
        """Create an instance of V1MetricValue from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1MetricValue:
        """Create an instance of V1MetricValue from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1MetricValue.parse_obj(obj)

        _obj = V1MetricValue.parse_obj({
            "metric_value_integer": obj.get("metricValueInteger"),
            "metric_value_double": obj.get("metricValueDouble")
        })
        return _obj

