# coding: utf-8

"""
    Risk Governance - Exceptions

    Retrieve, update, or create Exceptions as surfaced in Risk Radar.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskExceptionAPI.models.v1_risk_exceptions_query import V1RiskExceptionsQuery

class V1FilterRiskExceptionsRequest(BaseModel):
    """
    V1FilterRiskExceptionsRequest
    """
    query: Optional[V1RiskExceptionsQuery] = None
    page_token: Optional[StrictStr] = Field(None, alias="pageToken", description="A page token, received from a previous `FilterRiskExceptions` call. Provide this to retrieve the subsequent page.  When paginating, all other parameters provided to `FilterRiskExceptions` must match the call that provided the page token.")
    page_size: Optional[StrictInt] = Field(None, alias="pageSize")
    __properties = ["query", "pageToken", "pageSize"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1FilterRiskExceptionsRequest:
        """Create an instance of V1FilterRiskExceptionsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of query
        if self.query:
            _dict['query'] = self.query.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1FilterRiskExceptionsRequest:
        """Create an instance of V1FilterRiskExceptionsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1FilterRiskExceptionsRequest.parse_obj(obj)

        _obj = V1FilterRiskExceptionsRequest.parse_obj({
            "query": V1RiskExceptionsQuery.from_dict(obj.get("query")) if obj.get("query") is not None else None,
            "page_token": obj.get("pageToken"),
            "page_size": obj.get("pageSize")
        })
        return _obj

