# coding: utf-8

"""
    Risk Governance - Exceptions

    Retrieve, update, or create Exceptions as surfaced in Risk Radar.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskExceptionAPI.models.v1_risk_exception import V1RiskException

class V1FilterRiskExceptionsResponse(BaseModel):
    """
    V1FilterRiskExceptionsResponse
    """
    risk_exceptions: Optional[conlist(V1RiskException)] = Field(None, alias="riskExceptions")
    total_size: Optional[StrictInt] = Field(None, alias="totalSize")
    next_page_token: Optional[StrictStr] = Field(None, alias="nextPageToken", description="A token that can be sent as `pageToken` to retrieve the next page. If this field is omitted, there are no subsequent pages.")
    __properties = ["riskExceptions", "totalSize", "nextPageToken"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1FilterRiskExceptionsResponse:
        """Create an instance of V1FilterRiskExceptionsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in risk_exceptions (list)
        _items = []
        if self.risk_exceptions:
            for _item in self.risk_exceptions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['riskExceptions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1FilterRiskExceptionsResponse:
        """Create an instance of V1FilterRiskExceptionsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1FilterRiskExceptionsResponse.parse_obj(obj)

        _obj = V1FilterRiskExceptionsResponse.parse_obj({
            "risk_exceptions": [V1RiskException.from_dict(_item) for _item in obj.get("riskExceptions")] if obj.get("riskExceptions") is not None else None,
            "total_size": obj.get("totalSize"),
            "next_page_token": obj.get("nextPageToken")
        })
        return _obj

