# coding: utf-8

"""
    Risk Governance - Rules

    Retrieve, update, and create Rules and Rule Subscriptions as surfaced in Risk Radar.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskRuleAPI.models.v1_limit_definition import V1LimitDefinition
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskRuleAPI.models.v1_metric_unit import V1MetricUnit

class V1ConditionDefinitionOverride(BaseModel):
    """
    Captures the properties of the Condition that can be overridden when defining a RiskRuleOverride.
    """
    condition_id: StrictStr = Field(..., alias="conditionId", description="The condition id of the condition that is being overridden.")
    limit_definition_override: Optional[V1LimitDefinition] = Field(None, alias="limitDefinitionOverride")
    metric: Optional[StrictStr] = None
    metric_unit: Optional[V1MetricUnit] = Field(None, alias="metricUnit")
    metric_definition: Optional[StrictStr] = Field(None, alias="metricDefinition")
    __properties = ["conditionId", "limitDefinitionOverride", "metric", "metricUnit", "metricDefinition"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ConditionDefinitionOverride:
        """Create an instance of V1ConditionDefinitionOverride from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of limit_definition_override
        if self.limit_definition_override:
            _dict['limitDefinitionOverride'] = self.limit_definition_override.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ConditionDefinitionOverride:
        """Create an instance of V1ConditionDefinitionOverride from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ConditionDefinitionOverride.parse_obj(obj)

        _obj = V1ConditionDefinitionOverride.parse_obj({
            "condition_id": obj.get("conditionId"),
            "limit_definition_override": V1LimitDefinition.from_dict(obj.get("limitDefinitionOverride")) if obj.get("limitDefinitionOverride") is not None else None,
            "metric": obj.get("metric"),
            "metric_unit": obj.get("metricUnit"),
            "metric_definition": obj.get("metricDefinition")
        })
        return _obj

