# coding: utf-8

"""
    Risk Governance - Rules

    Retrieve, update, and create Rules and Rule Subscriptions as surfaced in Risk Radar.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, Optional
from pydantic import BaseModel, Field
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskRuleAPI.models.v1_limit import V1Limit

class V1LimitDefinition(BaseModel):
    """
    V1LimitDefinition
    """
    default_limit: Optional[V1Limit] = Field(None, alias="defaultLimit")
    sector_limits: Optional[Dict[str, V1Limit]] = Field(None, alias="sectorLimits")
    __properties = ["defaultLimit", "sectorLimits"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1LimitDefinition:
        """Create an instance of V1LimitDefinition from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of default_limit
        if self.default_limit:
            _dict['defaultLimit'] = self.default_limit.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each value in sector_limits (dict)
        _field_dict = {}
        if self.sector_limits:
            for _key in self.sector_limits:
                if self.sector_limits[_key]:
                    _field_dict[_key] = self.sector_limits[_key].to_dict()
            _dict['sectorLimits'] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1LimitDefinition:
        """Create an instance of V1LimitDefinition from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1LimitDefinition.parse_obj(obj)

        _obj = V1LimitDefinition.parse_obj({
            "default_limit": V1Limit.from_dict(obj.get("defaultLimit")) if obj.get("defaultLimit") is not None else None,
            "sector_limits": dict(
                (_k, V1Limit.from_dict(_v))
                for _k, _v in obj.get("sectorLimits").items()
            )
            if obj.get("sectorLimits") is not None
            else None
        })
        return _obj

