# coding: utf-8

"""
    Risk Governance - Tasks

    Retrieve Tasks, as surfaced in Risk Radar, which are aggregates that comprise of related Exceptions, Rules, and Workflow items.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, conlist
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskTaskAPI.models.v1_workflow_task_detail import V1WorkflowTaskDetail

class V1ListRiskTasksResponse(BaseModel):
    """
    V1ListRiskTasksResponse
    """
    workflow_task_details: Optional[conlist(V1WorkflowTaskDetail)] = Field(None, alias="workflowTaskDetails")
    __properties = ["workflowTaskDetails"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ListRiskTasksResponse:
        """Create an instance of V1ListRiskTasksResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in workflow_task_details (list)
        _items = []
        if self.workflow_task_details:
            for _item in self.workflow_task_details:
                if _item:
                    _items.append(_item.to_dict())
            _dict['workflowTaskDetails'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ListRiskTasksResponse:
        """Create an instance of V1ListRiskTasksResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ListRiskTasksResponse.parse_obj(obj)

        _obj = V1ListRiskTasksResponse.parse_obj({
            "workflow_task_details": [V1WorkflowTaskDetail.from_dict(_item) for _item in obj.get("workflowTaskDetails")] if obj.get("workflowTaskDetails") is not None else None
        })
        return _obj

