# coding: utf-8

"""
    Risk Governance - Tasks

    Retrieve Tasks, as surfaced in Risk Radar, which are aggregates that comprise of related Exceptions, Rules, and Workflow items.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskTaskAPI.models.v1_risk_exception import V1RiskException
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskTaskAPI.models.v1_risk_rule import V1RiskRule
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskTaskAPI.models.v1_risk_workflow import V1RiskWorkflow

class V1WorkflowTaskDetail(BaseModel):
    """
    V1WorkflowTaskDetail
    """
    risk_workflow: Optional[V1RiskWorkflow] = Field(None, alias="riskWorkflow")
    risk_exception: Optional[V1RiskException] = Field(None, alias="riskException")
    risk_rule: Optional[V1RiskRule] = Field(None, alias="riskRule")
    __properties = ["riskWorkflow", "riskException", "riskRule"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1WorkflowTaskDetail:
        """Create an instance of V1WorkflowTaskDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of risk_workflow
        if self.risk_workflow:
            _dict['riskWorkflow'] = self.risk_workflow.to_dict()
        # override the default output from pydantic by calling `to_dict()` of risk_exception
        if self.risk_exception:
            _dict['riskException'] = self.risk_exception.to_dict()
        # override the default output from pydantic by calling `to_dict()` of risk_rule
        if self.risk_rule:
            _dict['riskRule'] = self.risk_rule.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1WorkflowTaskDetail:
        """Create an instance of V1WorkflowTaskDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1WorkflowTaskDetail.parse_obj(obj)

        _obj = V1WorkflowTaskDetail.parse_obj({
            "risk_workflow": V1RiskWorkflow.from_dict(obj.get("riskWorkflow")) if obj.get("riskWorkflow") is not None else None,
            "risk_exception": V1RiskException.from_dict(obj.get("riskException")) if obj.get("riskException") is not None else None,
            "risk_rule": V1RiskRule.from_dict(obj.get("riskRule")) if obj.get("riskRule") is not None else None
        })
        return _obj

