# coding: utf-8

"""
    Risk Governance - Workflows

    Retrieve, update, and transition Workflow items as surfaced in Risk Radar.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskWorkflowAPI.models.v1_risk_workflow_activity import V1RiskWorkflowActivity

class V1RiskWorkflowRevisions(BaseModel):
    """
    Representation of Risk Workflow History.
    """
    id: Optional[StrictStr] = None
    workflow_activities: Optional[conlist(V1RiskWorkflowActivity)] = Field(None, alias="workflowActivities")
    exception_id: Optional[StrictStr] = Field(None, alias="exceptionId")
    workflow_description: Optional[StrictStr] = Field(None, alias="workflowDescription")
    rule_id: StrictStr = Field(..., alias="ruleId")
    scope_id: StrictStr = Field(..., alias="scopeId")
    scope_type: StrictStr = Field(..., alias="scopeType")
    __properties = ["id", "workflowActivities", "exceptionId", "workflowDescription", "ruleId", "scopeId", "scopeType"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1RiskWorkflowRevisions:
        """Create an instance of V1RiskWorkflowRevisions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in workflow_activities (list)
        _items = []
        if self.workflow_activities:
            for _item in self.workflow_activities:
                if _item:
                    _items.append(_item.to_dict())
            _dict['workflowActivities'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1RiskWorkflowRevisions:
        """Create an instance of V1RiskWorkflowRevisions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1RiskWorkflowRevisions.parse_obj(obj)

        _obj = V1RiskWorkflowRevisions.parse_obj({
            "id": obj.get("id"),
            "workflow_activities": [V1RiskWorkflowActivity.from_dict(_item) for _item in obj.get("workflowActivities")] if obj.get("workflowActivities") is not None else None,
            "exception_id": obj.get("exceptionId"),
            "workflow_description": obj.get("workflowDescription"),
            "rule_id": obj.get("ruleId"),
            "scope_id": obj.get("scopeId"),
            "scope_type": obj.get("scopeType")
        })
        return _obj

