# coding: utf-8

"""
    Risk Governance - Workflows

    Retrieve, update, and transition Workflow items as surfaced in Risk Radar.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from asdk_plugin_analytics.agraph.analytics.oversight.governance.v1.RiskWorkflowAPI.models.v1_risk_workflow_activity import V1RiskWorkflowActivity

class V1UpdateRiskWorkflowActivityRequest(BaseModel):
    """
    V1UpdateRiskWorkflowActivityRequest
    """
    risk_workflow_activity: Optional[V1RiskWorkflowActivity] = Field(None, alias="riskWorkflowActivity")
    update_mask: Optional[StrictStr] = Field(None, alias="updateMask", description="The list of fields to be updated.")
    __properties = ["riskWorkflowActivity", "updateMask"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1UpdateRiskWorkflowActivityRequest:
        """Create an instance of V1UpdateRiskWorkflowActivityRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of risk_workflow_activity
        if self.risk_workflow_activity:
            _dict['riskWorkflowActivity'] = self.risk_workflow_activity.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1UpdateRiskWorkflowActivityRequest:
        """Create an instance of V1UpdateRiskWorkflowActivityRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1UpdateRiskWorkflowActivityRequest.parse_obj(obj)

        _obj = V1UpdateRiskWorkflowActivityRequest.parse_obj({
            "risk_workflow_activity": V1RiskWorkflowActivity.from_dict(obj.get("riskWorkflowActivity")) if obj.get("riskWorkflowActivity") is not None else None,
            "update_mask": obj.get("updateMask")
        })
        return _obj

